// Percussion Synth globals

// instrument set; only define one
#define STANDARD_INSTRUMENTS
//#define JR_INSTRUMENTS

#define AUDIO_SAMPLE_RATE 22000 // Hz
// 16 bit mono sound sample buffer
// @ 22 KHz = ~5.8 msec
// @ 44 KHz = ~2.9 msec
#define SOUND_BLOCK_SIZE 128    // same as Teensy
// 2x audio sample buffers in circular buffer
// 2x stereo interleaved data
#define DMA_BUFSIZ (SOUND_BLOCK_SIZE*4) // words

// current UI sensor state
struct ui_controls_struct
{
  byte band_knob;   // pitch
  byte wave_knob;   // instrument
  byte effect_knob; // proximity effect
  byte proximity;   // proximity
  boolean proximity_enabled;
};

// instruments configuration
#define WT_WAVE   0
#define WT_STRING 1
#define WT_DRUM   2

// pitch knob divisions
#define NBR_BAND_SETTINGS 5 // -2,-1,0,+1,+2

// Wave knob instruments
#define NBR_WAVE_SETTINGS (sizeof(instrument) / sizeof(struct instrument_table))
struct instrument_table
{ byte wt;          // WT_WAVE/STRING/DRUM
  byte notes_scale; // applies to wave/string only
};

// note table variations
//#define NUM_SCALES (sizeof(NOTES) / sizeof(struct notes_table))
#ifdef STANDARD_INSTRUMENTS
#define NUM_SCALES 3
#endif
#ifdef JR_INSTRUMENTS
#define NUM_SCALES 4
#endif
struct notes_table
{ const float *frequency;
};
#define SCALE_OCTAVE           0
#define SCALE_MINOR_PENTATONIC 1
#define SCALE_MAJOR_PENTATONIC 2
#define SCALE_7UP              3

// in main
extern struct instrument_table instrument[];
extern struct notes_table NOTES[];
extern const int16_t *wavetable[];

