#ifndef synth_wave_h_
#define synth_wave_h_

#define NBR_WAVE_EFFECTS 5

#define ENV_IDLE    0
#define ENV_ATTACK  1
#define ENV_DECAY   2
#define ENV_SUSTAIN 3
#define ENV_RELEASE 4
#define ENV_QUELCH  5

class synth_instrument_wave
{
  public:
  
    synth_instrument_wave()
    {
      env_state = ENV_IDLE;
      attack (1000); // ms
      decay  (1000); // ms
      sustain(0.5f); // multiplier
      release(1000); // ms
      quelch (  50); // ms
    }

    void attack(uint16_t milliseconds);
    void decay(uint16_t milliseconds);
    void sustain(float level);
    void release(uint16_t milliseconds);
    void quelch(uint16_t milliseconds);
     
    void startInstrument( ui_controls_struct *ui, int key );
    void stopInstrument();
    void release();
    void updateInstrument( ui_controls_struct *ui );
    byte runInstrument( int32_t *buf );
  
  private:

    ui_controls_struct *start_ui; 
    int start_key;

    // envelope
    uint16_t attack_count;
    uint16_t decay_count;
     int32_t sustain_mult;
    uint16_t release_count;
    uint16_t quelch_count;    
    uint8_t  env_state;
    uint16_t env_count;  // x8 samples
    int32_t  env_mult32; // attenuation, 0=off, 0x40000000=unity gain
    int32_t  env_inc32;  // amount to change mult every 8 samples
    uint16_t milliseconds2count(uint32_t milliseconds);
    
    // table driven wave signal generator
    float    frequency;
    uint32_t dds_tune0;
    uint32_t dds_tune;
    uint32_t dds_phase;
};

#endif

